﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using Telerik.Windows.Controls;

namespace RadAutoCompleteBox_WPF_740642
{
    public class ViewModel : ViewModelBase
    {
        private ObservableCollection<Employee> employeeItems;

        public ObservableCollection<Employee> EmployeeItems
        {
            get { return employeeItems; }
            set { employeeItems = value; this.OnPropertyChanged("EmployeeItems"); }
        }

        private Employee selectedEmployee;

        public Employee SelectedEmployee
        {
            get { return selectedEmployee; }
            set { selectedEmployee = value; this.OnPropertyChanged("SelectedEmployee"); }
        }

        private string searchText;

        public string SearchText
        {
            get { return searchText; }
            set { searchText = value; this.OnPropertyChanged("SearchText"); this.GetItemsSource(); }
        }

        private ObservableCollection<Employee> selectedEmployees;

        public ObservableCollection<Employee> SelectedEmployees
        {
            get { return selectedEmployees; }
            set { selectedEmployees = value; this.OnPropertyChanged("SelectedEmployees"); }
        }


        private bool isDropDownOpen;

        public bool IsDropDownOpen
        {
            get { return isDropDownOpen; }
            set { isDropDownOpen = value; this.OnPropertyChanged("IsDropDownOpen"); }
        }

        

        private void GetItemsSource()
        {
            ////this.OnPropertyChanged("EmployeeItems");
            // Get the items from DB based on the SearchedText
            List<Employee> items = DataHelper.GetItems(this.SearchText, this.SelectedEmployees.ToList());
            this.EmployeeItems = new ObservableCollection<Employee>(items);
            this.IsDropDownOpen = true;
        }

        public ViewModel()
        {
            this.EmployeeItems = new ObservableCollection<Employee>();
            this.SelectedEmployees = new ObservableCollection<Employee>();
        }
    }
}
